<?php
// Copyright (C) 2008 - 2010 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
require '/var/www/html/libs/Smarty.class.php';

$smarty = new Smarty;
$smarty->caching = 0;

$smarty->compile_check = true;
$smarty->debugging = false;

require '/var/www/html/libs/vortexbox_defs.php';
require '/var/www/html/libs/vortexbox_smarty.php';


$_action = isset($_REQUEST['action']) ? $_REQUEST['action'] : 'default';

//set defaults
$bind = 0;

switch($_action) {

    case 'submit':

	// check to see if user wants Sonos shares
	if (isset($_REQUEST['SONOS'][0]) & !$_REQUEST['SONOS'][0] =="") {
		exec("touch /etc/vortexbox/sonos.smb");
	} else {
		exec("rm /etc/vortexbox/sonos.smb");
	}
	
	// check to see if user wants to run Bind
	if (isset($_REQUEST['BIND'][0]) & !$_REQUEST['BIND'][0] =="") {
		exec("touch /etc/vortexbox/bind_enabled");
		$bind = 1;
	} else {
		exec("rm /etc/vortexbox/bind_enabled");
	}	
		
	$lines = file($file);
	$config = array();
 
	foreach ($lines as $line_num=>$line) {
		if ( ! preg_match("/#.*/", $line) ) {
		# Contains non-whitespace?
		if ( preg_match("/\S/", $line) ) {
		list( $key, $value ) = explode( "=", trim( $line ), 2);
		$config[$key] = $value;
		$smarty->assign($key, $config[$key]); 
		}
	  }
	}

	if (isset($_REQUEST['WORKGROUP']) & !$_REQUEST['WORKGROUP'] =="") { $WORKGROUP = $_REQUEST['WORKGROUP']; }
	if (isset($_REQUEST['SYSNAME']) & !$_REQUEST['SYSNAME'] =="") { $SYSNAME = $_REQUEST['SYSNAME']; }
	$smarty->assign('WORKGROUP', $WORKGROUP);
	$smarty->assign('SYSNAME', strtolower($SYSNAME));
	
	
	if (isset($_REQUEST['BOOTPROTO']) & !$_REQUEST['BOOTPROTO'] =="") { $config['BOOTPROTO'] = $_REQUEST['BOOTPROTO']; }
	if (isset($_REQUEST['IPADDR']) & !$_REQUEST['IPADDR'] =="") { $config['IPADDR'] = $_REQUEST['IPADDR']; }
	if (isset($_REQUEST['NETMASK']) & !$_REQUEST['NETMASK'] =="") { $config['NETMASK'] = $_REQUEST['NETMASK']; }
	if (isset($_REQUEST['GATEWAY']) & !$_REQUEST['GATEWAY'] =="") { $config['GATEWAY'] = $_REQUEST['GATEWAY']; }
	if (isset($_REQUEST['DNS1']) & !$_REQUEST['DNS1'] =="") { $config['DNS1'] = $_REQUEST['DNS1']; }
	if (isset($_REQUEST['DNS2']) & !$_REQUEST['DNS2'] =="") { $config['DNS2'] = $_REQUEST['DNS2']; }
	if (isset($_REQUEST['DNS3']) & !$_REQUEST['DNS3'] =="") { $config['DNS3'] = $_REQUEST['DNS3']; }

	if (isset($_REQUEST['DNS1']) & $_REQUEST['DNS1'] =="") { 
		$config['DNS1'] = "208.67.222.222";
		$config['DNS2'] = "208.67.220.220";
	}
	
	if (isset($_REQUEST['DNS1']) & $_REQUEST['DNS1'] =="" & $bind == 1) { 
		$config['DNS1'] = "127.0.0.1";
		$config['DNS2'] = "208.67.220.220";
		$config['DNS3'] = "208.67.222.222";
	}
	
	if ($config['BOOTPROTO'] == "dhcp")
	{
		unset($config['IPADDR']);
		unset($config['NETMASK']);
		unset($config['GATEWAY']);
		unset($config['DNS1']);
		unset($config['DNS2']);
		unset($config['DNS3']);
	}

	
	
	if ($fp = fopen($tempfile, 'w')) {
	fwrite($fp, "# Created by VortexBox web admin\n");

	foreach($config as $key=>$val) {

	  $new_val = false;
	  $config_str = "";

	  $smarty->assign($key, $config[$key]); 

	  $config_str = $key."=".$config[$key]."\n";
	  fwrite($fp, $config_str, strlen($config_str));
	}
	fclose($fp); 

	} else {
		echo 'Config file unwritable... '; 
	}
	
	exec("sudo /opt/vortexbox/setup_network.sh $SYSNAME $WORKGROUP & >/dev/null 2>&1");
	
        break;
    default:
	
	$lines = file($smbfile);
	$smblines = array();
 
	foreach ($lines as $line_num=>$line) {
		if ( ! preg_match("/#.*/", $line) ) {
		# Contains non-whitespace?
		if ( preg_match("/\S/", $line) ) {
		list( $key, $value ) = explode( "=", trim( $line ), 2);
		$smblines[trim($key)] = trim($value);
		}
	  }
	}

$smarty->assign('WORKGROUP', $smblines['workgroup']);
$smarty->assign('SYSNAME', strtolower($smblines['netbios name']));
	
	$lines = file($file);
	$config = array();
 
	foreach ($lines as $line_num=>$line) {
	# Comment?
	if ( ! preg_match("/#.*/", $line) ) {
		# Contains non-whitespace?
		if ( preg_match("/\S/", $line) ) {
		list( $key, $value ) = explode( "=", trim( $line ), 2);
		$config[$key] = $value;
		$smarty->assign($key, $config[$key]); 
		}
	  }
	}   
        break;   
}

if ($config['BOOTPROTO'] == "") 
{
$config['BOOTPROTO'] = "dhcp";
$smarty->assign('BOOTPROTO', "dhcp"); 
}


$smarty->assign('iptype_name', array(
					'dhcp' => 'DHCP',
					'none' => 'Static IP address'
                     ));

$smarty->assign('sonos_checkbox', array(
					'sonos' => 'Enable Sonos share',
                     ));

if (file_exists("/etc/vortexbox/sonos.smb")) {
    $smarty->assign('sonos_ischecked', "sonos");
} else {
   $smarty->assign('sonos_ischecked', "no");
}

$smarty->assign('bind_checkbox', array(
					'bind' => 'Enable Bind',
                     ));

if (file_exists("/etc/vortexbox/bind_enabled")) {
    $smarty->assign('bind_ischecked', "bind");
} else {
   $smarty->assign('bind_ischecked', "no");
}				 

$smarty->display('network.tpl');

?>
