<?php
// Copyright (C) 2008 - 2010 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
require '/var/www/html/libs/Smarty.class.php';

$smarty = new Smarty;
$smarty->caching = 0;

$smarty->compile_check = true;
$smarty->debugging = false;

$configfile = "/var/www/html/config/daap.cfg";
$deftemplate = "/var/www/html/config/forked-daapd.conf.template";
$daapconf = "/var/tmp/forked-daapd.conf";

include '/var/www/html/libs/SearchReplace.php' ;
require '/var/www/html/libs/vortexbox_defs.php';
require '/var/www/html/libs/vortexbox_smarty.php';

$_action = isset($_REQUEST['action']) ? $_REQUEST['action'] : 'default';
$config = array();

if (file_exists($configfile)) {
    $config = array();
} else {
// build default if required
    $config = array( "DIRECTORIES" => "/storage/music/flac", "DESCRIPTION" => "VortexBox" );

	$fp = fopen($configfile,'w');
	fwrite($fp,serialize($config));
	fclose($fp);	
}
	
switch($_action) {

    case 'submit':

		if (isset($_REQUEST['DIRECTORIES']) & !$_REQUEST['DIRECTORIES'] =="") { $config['DIRECTORIES'] = $_REQUEST['DIRECTORIES']; }
		if (isset($_REQUEST['DESCRIPTION']) & !$_REQUEST['DESCRIPTION'] =="") { $config['DESCRIPTION'] = $_REQUEST['DESCRIPTION']; }
		$fp = fopen($configfile,'w');
		fwrite($fp,serialize($config));
		fclose($fp);
		
		$files_to_search = array($daapconf);
		$search_string  = array('##DIRECTORIES##','##DESCRIPTION##');
		$replace_string = array($config['DIRECTORIES'], $config['DESCRIPTION']);
		copy($deftemplate, $daapconf);
 
		$snr = new File_SearchReplace($search_string,
                              $replace_string,
                              $files_to_search,
                              $direc_to_search,
                              true) ;
		$snr->doSearch();
		
		exec("sudo /opt/vortexbox/doaction.sh RestartDAAP & >/dev/null 2>&1");
	
		break;

	case 'ResetDefaults':
		$config = array( "DIRECTORIES" => "/storage/music/flac", "DESCRIPTION" => "VortexBox" );
        break;
	
	default:
		$configall = file_get_contents($configfile);
		$config = unserialize($configall); 
}

foreach ($config as $key => $value) {
   $smarty->assign($key,$value);
}

$smarty->display('daap.tpl');
?>
