<?php
// Copyright (C) 2008 - 2010 vortexbox.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

$file = "/etc/sysconfig/network-scripts/ifcfg-eth0";
$SimplifyMediaConfig = "/etc/vortexbox/SimplifyMediaConfig.txt";
$lamopt = "/etc/vortexbox/lameopt.txt";
$CurrentUsbDriveFile = "/etc/vortexbox/CurrentUsbDrive.txt";
$smbfile = "/etc/samba/smb.conf";
$tempfile = "/var/tmp/ifcfg-eth0.new";
$SYSNAME = "vortexbox";
$WORKGROUP = "WORKGROUP";
$VortexBoxVersion = exec("cat /etc/vortexbox/vortexbox-version");

function StripExtraSpace($s)
{
	for($i = 0; $i < strlen($s); $i++)
	{
	  $newstr = $newstr . substr($s, $i, 1);
	  if(substr($s, $i, 1) == ' ')
	  while(substr($s, $i + 1, 1) == ' ')
	  $i++;
	}
return $newstr;
} 

$servicestatus = array (
	"vortexbox" 		=> array ( 	"Name" => "Auto CD Ripper",
									"Status" => "Unknown",
							),
	"forked-daapd" 		=> array ( 	"Name" => "DAAP (iTunes) Server",
									"Status" => "Unknown",
							),
	"minidlna" 			=> array ( 	"Name" => "DLNA Server",
									"Status" => "Unknown",
							),
	"smb"				=> array ( 	"Name" => "Samba Server",
									"Status" => "Unknown",
							),							
	"squeezeboxserver"	=> array ( 	"Name" => "SqueezeBox Server",
									"Status" => "Unknown",
							),
	"vortexbox-player"	=> array ( 	"Name" => "VortexBox Player",
									"Status" => "Unknown",
							)							
);

foreach ($servicestatus as $key => $value) {
	$servicestatus[$key]["Status"] = exec("sudo /opt/vortexbox/doaction.sh ServiceStatus ".$key);
}

// Determine MAC address, NIC, and IP address - check for eth0, eth1, and wlan0.

$eth0_macaddress = exec("ifconfig | grep eth0 | awk -F 'HWaddr ' '{ print $2 }'");
if ($eth0_macaddress) {
    // eth0 exists - use it
    $macaddress = $eth0_macaddress;
    $nic = "eth0";
    $ipaddress = exec('ifconfig eth0 | grep "inet addr" | sed "s/^ *inet addr://" | cut -d" " -f1');
} else {
    // no eth0 - check for eth1
    $eth1_macaddress = exec("ifconfig | grep eth1 | awk -F 'HWaddr ' '{ print $2 }'");
    if ($eth1_macaddress) {
        // eth1 exists - use it
        $macaddress = $eth1_macaddress;
        $nic = "eth1";
        $ipaddress = exec('ifconfig eth1 | grep "inet addr" | sed "s/^ *inet addr://" | cut -d" " -f1');
    } else {
        // no eth1 - check for wlan0
        $wlan0_macaddress = exec("ifconfig | grep wlan0 | awk -F 'HWaddr ' '{ print $2 }'");
        if ($wlan0_macaddress) {
            // wlan0 exists - use it
            $macaddress = $wlan0_macaddress;
            $nic = "wlan0";
            $ipaddress = exec('ifconfig wlan0 | grep "inet addr" | sed "s/^ *inet addr://" | cut -d" " -f1');
        }
    }
}

$SCport = ":".trim(exec("grep 'httpport:' /var/lib/squeezeboxserver/prefs/server.prefs | tail -1 | /bin/awk '{print $2}'"));

?>
